$(document).on("ready", function () {
  var document_id = $("#download-all").data("document-id");
  var intervalId; // Declare intervalId variable in outer scope

  // Function to check if download is ready
  function checkDownloadStatus() {
    if (document_id) {
      $.ajax({
        url: "/download_all/button_ready/" + document_id,
        type: "GET",
        dataType: "json",
        success: function (response) {
          if (response.is_ready) {
            $("#download-all").attr("disabled", false);
            clearInterval(intervalId); // Clear the interval
          }
        },
        error: function (request, error) {
          console.error("Request error:", error);
        },
      });
    }
  }

  $(document).ready(function () {
    $("#with_files_submit").click(function () {
      // Check if overlay already exists; if not, create it
      if ($("#overlay").length === 0) {
        // Create overlay element
        $("body").append(`
          <div id="overlay" class="overlay" style="display: flex;">
          </div>
        `);

        // Add CSS styles dynamically
        $("<style>")
          .prop("type", "text/css")
          .html(
            `
            #overlay {
              position: fixed;
              top: 0;
              left: 0;
              width: 100%;
              height: 100%;
              background-color: rgba(0, 0, 0, 0.1); 
              justify-content: center;                 
              align-items: center;
              z-index: 1000; 
              display: flex;
              pointer-events: auto; /* Allow pointer events on overlay */
            }
            body.disable-clicks > *:not(#overlay) {
              pointer-events: none; /* Disable pointer events on everything except the overlay */
            }
            `
          )
          .appendTo("head");
      }

      // Disable background clicks
      $("body").addClass("disable-clicks");

      // Show the overlay
      $("#overlay").fadeIn();

      // Hide the overlay and re-enable clicks when clicking on it
      // $("#overlay").click(function () {
      //   $(this).fadeOut(function () {
      //     $(this).remove(); // Remove the overlay from the DOM after fading out
      //     $("body").removeClass("disable-clicks"); // Re-enable clicks on background elements
      //   });
      // });
    });
  });

  // Initial check on document ready
  checkDownloadStatus();

  // Set interval to check every 2 minutes (120,000 milliseconds)
  intervalId = setInterval(checkDownloadStatus, 120000);
});
