require "./lib/vocabularies/rdms"
# frozen_string_literal: true
# Generated by hyrax:models
class Collection < ActiveFedora::Base
  include ::Hyrax::CollectionBehavior
  # You can replace these metadata if they're not suitable
  self.indexer = Hyrax::CollectionWithBasicMetadataIndexer
  after_destroy :remove_dependent_roles, if: -> { collection_type.title == 'CRC 1280' }

  property :crc_collection_type, predicate: ::RDF::Vocab::Rdms.crcCollectionType, multiple: false do |index|
    index.as :stored_searchable
  end

  include Hyrax::BasicMetadata

  def after_update_nested_collection_relationship_indices
    @during_save = false
    reindex_nested_relationships_for(id: id, extent: Hyrax::Adapters::NestingIndexAdapter::LIMITED_REINDEX)
  end

  def update_nested_collection_relationship_indices
    return if @during_save
    reindex_nested_relationships_for(id: id, extent: Hyrax::Adapters::NestingIndexAdapter::LIMITED_REINDEX)
  end

  def manager_role
    Role.find_by_name("#{collection_type.title.parameterize(separator: '_')}_manager")
  end

  def member_role
    Role.find_by_name("#{collection_type.title.parameterize(separator: '_')}_member")
  end

  def manager_role_for_group
    Role.find_by_name("#{collection_type.title.parameterize(separator: '_')}_#{id}_manager")
  end

  def member_role_for_group
    Role.find_by_name("#{collection_type.title.parameterize(separator: '_')}_#{id}_member")
  end

  private

  def remove_dependent_roles
    roles = if crc_collection_type == "group"
      [manager_role_for_group, member_role_for_group]
    else
      [manager_role, member_role]
    end

    roles.compact.each do |role|
      remove_worflow_roles(role)

      role.destroy
    end
  end

  def remove_worflow_roles(role)
    role.users.each { |user| user.remove_workflow_role(role) }
  end
end
