# frozen_string_literal: true
namespace :rdms do
  desc "Fix date recorded for complex sessions. usage: rdms:fix_complex_sessions_date_recorded"
  task fix_complex_sessions_date_recorded: :environment do
    ComplexSession.where.not("session_date_recorded ~ ?", '^\d{4}-\d{2}-\d{2}$').each do |session|
      # Fixing date recorded for complex session
      puts "Fixing date recorded for complex session #{session.id}"
      begin
        dt = session.session_date_recorded.gsub('-', "/")
        new_date = DateTime.parse(dt).strftime('%Y-%m-%d')
        session.update(session_date_recorded: new_date)
      rescue
        puts "error Fixing date recorded for complex session #{session.id}"
      end
    end
  end
end
