require 'json'

namespace :rdms do
  namespace :crc_1280_import do
    desc 'Verify all experiments in CRC1280 import. This will compare the files in the file path with the objects in the S3 bucket'
    task :verify_import, [:import_id] => :environment do |task, args|
      puts "Verifying import #{args.import_id.to_i}"
      import_status, report_paths = VerifyCRCDatasetImport.verify_import(args.import_id.to_i)
      puts "import status : #{import_status}"
      puts "Detailed reports are available at:"
      puts JSON.pretty_generate(report_paths)
    end
    desc 'Verify experiment in CRC1280 import. This will compare the files in the file path with the objects in the S3 bucket'
    task :verify_experiment, [:import_id, :entry_id] => :environment do |task, args|
      puts "Verifying experiment #{args.entry_id.to_i} in import #{args.import_id.to_i}"
      experiment_status, report_path = VerifyCRCDatasetImport.verify_experiment_and_report(args.import_id.to_i, args.entry_id.to_i)
      puts "Experiment import status : #{experiment_status}"
      puts "Detailed reports is available at: #{report_path}"
    end
  end
end
